﻿function fGetPageAsinList(asin) {
    var product = SSTool.fGetProduct(document), asins = (asin == null || asin == '') ? [] : [{id: 0, asin: asin, title: product.title, img: product.image}],
        v = document.querySelectorAll('li[data-defaultasin]'), l = document.querySelectorAll('a[href*=B0]'), container = {};

    for (var i = 0; i < v.length; i++) {
        var _a = v[i].getAttribute('data-defaultasin'), img = v[i] && v[i].querySelector('img[src]'),
            txt = (img && img['alt'] || v[i].title || v[i].text).replace(/(^\s*)|(\s*$)/g, '').replace(/[\s|\t]{2,}/, '\s');
        _a && _a && _a != asin && _a != '' && txt != '' && container[_a] == null && img
        && asins.push({
            id: asins.length,
            asin: _a,
            title: txt,
            img: img['src']
        }) && (container[_a] = 'Y');
    }

    for (var i = 0; i < l.length; i++) {
        var h = decodeURIComponent(l[i]['href'] || ''), m = h && h.match(/\bB0[A-Z0-9]{8,10}\b/), img = l[i] && l[i].querySelector('img[src*=images][alt]'),
            txt = (img && img['alt'] || l[i].title || l[i].text).replace(/(^\s*)|(\s*$)/g, '').replace(/[\s|\t]{2,}/, '\s');
        m && m[0] && m[0] != asin && m[0] != '' && txt != '' && container[m[0]] == null && img
        && asins.push({
            id: asins.length,
            asin: m[0],
            title: txt,
            img: img['src']
        }) && (container[m[0]] = 'Y');
    }

    return asins
}

function fBindEvents() {
    $(document).ready(function () {
        var _url = document.location.href, _host = document.location.host;

        // 当前在亚马逊站点
        if (SSTool.fGetAmazonStation(_url) && SSTool.fGetAsin(_url)) {
            var station = SSTool.fGetAmazonStation(_url).toUpperCase(), asin = SSTool.fGetAsin(_url);
            chrome.runtime.sendMessage({
                type: 'asinseed-product-init',
                station: station,
                asin: asin,
                product: JSON.stringify(SSTool.fGetProduct())
            });

            chrome.runtime.sendMessage({
                type: 'asinseed-product-list-init',
                station: station,
                md5: CryptoJS.MD5(_url).toString(),
                list: JSON.stringify(fGetPageAsinList(asin))
            });
        } else if (SSTool.fGetAmazonStation(_url)) {
            var station = SSTool.fGetAmazonStation(_url).toUpperCase();
            chrome.runtime.sendMessage({
                type: 'asinseed-product-list-init',
                station: station,
                md5: CryptoJS.MD5(_url).toString(),
                list: JSON.stringify(fGetPageAsinList())
            });
        }

        // 当前在AsinSeed站点
        if (_host.indexOf('asinseed.com') >= 0) {
            var $user = $('#sidebarAccountInvoker [data-user-email][data-user-surname]'), cookies = document.cookie.split(';'), cookie = null;
            if ($user.length == 1) {
                for (var i in cookies) {
                    if (cookies[i].indexOf('asinseed-login-user=') >= 0) {
                        cookie = cookies[i].replace('asinseed-login-user=', '').replace(/(^\s*)|(\s*$)/g, '');
                        break;
                    }
                }

                if (cookie) {
                    var email = $user.attr('data-user-email'), surname = $user.attr('data-user-surname');
                    chrome.runtime.sendMessage({
                        type: 'asinseed-user-init',
                        email: email,
                        surname: surname,
                        token: cookie
                    });
                }
            }
        }

    });

    chrome.extension.onMessage.addListener(function (request, sender, sendResponse) {
        if (request.type == "cal-asinseed-product-list") {
            var _url = window.location.href, station = SSTool.fGetAmazonStation(_url).toUpperCase(), asin = SSTool.fGetAsin(_url);
            chrome.runtime.sendMessage({
                type: 'asinseed-product-list-init',
                station: station,
                md5: CryptoJS.MD5(_url).toString(),
                list: JSON.stringify(fGetPageAsinList(asin))
            });
            sendResponse({code: "done"})
        }
    });
}


fBindEvents();